VMPlugin (Groovy 5.0.0)

Package: org.codehaus.groovy.vmplugin

## [Java] Interface VMPlugin

-     public interface VMPlugin

  Interface to access VM version based actions. This interface is for internal use only!

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public boolean` | `checkAccessible(Class<?> callerClass, Class<?> declaringClass, int memberModifiers, boolean allowIllegalAccess)` check whether the member can be accessed or not
    `` | `public boolean` | `checkCanSetAccessible(AccessibleObject accessibleObject, Class<?> callerClass)` Check whether invoking AccessibleObject.setAccessible on the accessible object will be completed successfully
    `` | `public void` | `configureAnnotation(AnnotationNode an)`
    `` | `public void` | `configureAnnotationNodeFromDefinition(AnnotationNode definition, AnnotationNode root)`
    `` | `public void` | `configureClassNode(CompileUnit compileUnit, ClassNode classNode)`
    `<T>` | `public T` | `doPrivileged(PrivilegedAction<T> action)` Performs the specified PrivilegedAction with privileges enabled on platforms which support that capability, otherwise the action is performed ignoring privileges.
    `<T>` | `public T` | `doPrivileged(PrivilegedExceptionAction<T> action)` Performs the specified PrivilegedExceptionAction with privileges enabled on platforms which support that capability, otherwise the action is performed ignoring privileges.
    `` | `public Map<String, Set<String>>` | `getDefaultImportClasses(String[] packageNames)` Returns the default import classes: class name -> the relevant package names
    `` | `public Object` | `getInvokeSpecialHandle(Method m, Object receiver)` Returns a handle with bound receiver to invokeSpecial the given method.
    `` | `public static String` | `getJavaVersion()` Returns java version, e.g. 1.8, 9, 11, 17
    `` | `public Class[]` | `getPluginDefaultGroovyMethods()`
    `` | `public Class[]` | `getPluginStaticGroovyMethods()`
    `` | `public List<String>` | `getRecordComponentNames(Class<?> maybeRecord)` Returns the list of record component names or the empty list if the class is not a record or running on a pre16 JDK.
    `` | `public int` | `getVersion()` Gives the version the plugin is made for
    `` | `public void` | `invalidateCallSites()`
    `` | `public Object` | `invokeHandle(Object handle, Object[] args)` Invokes a handle produced by #getInvokeSpecialdHandle
    `` | `public void` | `setAdditionalClassInformation(ClassNode c)`
    `` | `public MetaMethod` | `transformMetaMethod(MetaClass metaClass, MetaMethod metaMethod, Class<?> caller)` transform meta method
    `` | `public MetaMethod` | `transformMetaMethod(MetaClass metaClass, MetaMethod metaMethod)` transform meta method.
    `` | `public boolean` | `trySetAccessible(AccessibleObject ao)` Set the `accessible` flag for this reflected object to `true` if possible.

- - ### Method Detail

    - #### public boolean checkAccessible(Class<?> callerClass, Class<?> declaringClass, int memberModifiers, boolean allowIllegalAccess)

      check whether the member can be accessed or not

      Parameters:
        `callerClass` - callerClass the callerClass to invoke `setAccessible`
        `declaringClass` - the type of member owner
        `memberModifiers` - modifiers of member
        `allowIllegalAccess` - whether to allow illegal access
      Returns:
        the result of checking

    - #### public boolean checkCanSetAccessible(AccessibleObject accessibleObject, Class<?> callerClass)

      Check whether invoking AccessibleObject.setAccessible on the accessible object will be completed successfully

      Parameters:
        `accessibleObject` - the accessible object to check
        `callerClass` - the callerClass to invoke `setAccessible`
      Returns:
        the check result

    - #### public void configureAnnotation(AnnotationNode an)

    - #### public void configureAnnotationNodeFromDefinition(AnnotationNode definition, AnnotationNode root)

    - #### public void configureClassNode(CompileUnit compileUnit, ClassNode classNode)

    - #### <T> @Deprecated
      public T doPrivileged(PrivilegedAction<T> action)

      Performs the specified PrivilegedAction with privileges enabled on platforms which support that capability, otherwise the action is performed ignoring privileges.

      Parameters:
        `action` - the action to be performed
      Type Parameters:
        `T` - the type of the value returned by the PrivilegedAction's run method
      Returns:
        the value returned by the action's run method

    - #### <T> @Deprecated
      public T doPrivileged(PrivilegedExceptionAction<T> action)

      Performs the specified PrivilegedExceptionAction with privileges enabled on platforms which support that capability, otherwise the action is performed ignoring privileges.

      Parameters:
        `action` - the action to be performed
      Type Parameters:
        `T` - the type of the value returned by the PrivilegedAction's run method
      Returns:
        the value returned by the action's run method

    - #### public Map<String, Set<String>> getDefaultImportClasses(String[] packageNames)

      Returns the default import classes: class name -> the relevant package names

      Parameters:
        `packageNames` - the default import package names, e.g. java.lang.
      Returns:
        the default import classes
      Since:
        3.0.2

    - #### public Object getInvokeSpecialHandle(Method m, Object receiver)

      Returns a handle with bound receiver to invokeSpecial the given method. This method will require at least Java 7, but since the source has to compile on older Java versions as well it is not marked to return a MethodHandle and uses Object instead

      Returns:
        null in case of jdk<7, otherwise a handle that takes the method call arguments for the invokespecial call

    - #### @Deprecated
      public static String getJavaVersion()

      Returns java version, e.g. 1.8, 9, 11, 17

      deprecated:
      Returns:
        java version
      Since:
        4.0.0

    - #### public Class[] getPluginDefaultGroovyMethods()

    - #### public Class[] getPluginStaticGroovyMethods()

    - #### @Incubating
      public List<String> getRecordComponentNames(Class<?> maybeRecord)

      Returns the list of record component names or the empty list if the class is not a record or running on a pre16 JDK.

      Parameters:
        `maybeRecord` - the class in question
      Returns:
        the default list of names
      Since:
        4.0.15

    - #### public int getVersion()

      Gives the version the plugin is made for

      Returns:
        7 for jdk7, 8 for jdk8, 9 for jdk9 or higher

    - #### public void invalidateCallSites()

    - #### public Object invokeHandle(Object handle, Object[] args)

      Invokes a handle produced by #getInvokeSpecialdHandle

      Parameters:
        `handle` - the handle
        `args` - arguments for the method call, can be empty but not null
      Returns:
        the result of the method call

    - #### public void setAdditionalClassInformation(ClassNode c)

    - #### public MetaMethod transformMetaMethod(MetaClass metaClass, MetaMethod metaMethod, Class<?> caller)

      transform meta method

      Parameters:
        `metaClass` - metaclass
        `metaMethod` - the original meta method
        `caller` - caller class, whose method sets accessible for methods
      Returns:
        the transformed meta method

    - #### public MetaMethod transformMetaMethod(MetaClass metaClass, MetaMethod metaMethod)

      transform meta method.

      Parameters:
        `metaClass` - metaclass
        `metaMethod` - the original meta method
      Returns:
        the transformed meta method

    - #### public boolean trySetAccessible(AccessibleObject ao)

      Set the `accessible` flag for this reflected object to `true` if possible.

      throws:
        SecurityException if the request is denied by the security manager
      Parameters:
        `ao` - the accessible object
      Returns:
        `true` if the `accessible` flag is set to `true`; `false` if access cannot be enabled.